HDU1695(容斥原理)

GCD

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 6017    Accepted Submission(s): 2203


Problem Description
Given 5 integers: a, b, c, d, k, you're to find x in a...b, y in c...d that GCD(x, y) = k. GCD(x, y) means the greatest common divisor of x and y. Since the number of choices may be very large, you're only required to output the total number of different number pairs.
Please notice that, (x=5, y=7) and (x=7, y=5) are considered to be the same.

Yoiu can assume that a = c = 1 in all test cases.
 

Input
The input consists of several test cases. The first line of the input is the number of the cases. There are no more than 3,000 cases.
Each case contains five integers: a, b, c, d, k, 0 < a <= b <= 100,000, 0 < c <= d <= 100,000, 0 <= k <= 100,000, as described above.
 

Output
For each test case, print the number of choices. Use the format in the example.
 

Sample Input
   
   
   
   
2 1 3 1 5 1 1 11014 1 14409 9
 

Sample Output
   
   
   
   
Case 1: 9 Case 2: 736427
Hint

For the first sample input, all the 9 pairs of numbers are (1, 1), (1, 2), (1, 3), (1, 4), (1, 5), (2, 3), (2, 5), (3, 4), (3, 5).

题意:在[1,b]和[1,d]中各选一个数i,j,是的GCD(i,j)=k,求满足的(i,j)对数,(i,j)和(j,i)算一种

思路:等价于求[1,b/k]和[1,d/k]中各选一个数i,j,使得i,j互素

对于i>=j,只需要累加小于i且与i互质的数的个数就好了,这个可以用欧拉函数求

对于i<j,需要用容斥原理搞,对于每个j,先处理出它的所有素因子,然后按这些素因子的集合容斥就好了,这样是可以算出1-i的所有与j

不互素的个数,然后用i减去这部分就是互素的个数了

你可能感兴趣的:(ACM,HDU)